<template>
  <div :class="['gallery', galleryType]">
    <img v-for="(image, i) in images" :key="i" :src="`${baseUrl}/${image.path}`" :alt="image.alt" :class="[`img-${i + 1}`, 'img']"/>
  </div>
</template>

<script>
export default {
  name: "Gallery",
  props: {
    images: {
      type: Array,
      required: true
    }
  },
  data() {
    return {
      baseUrl: process.env.baseUrl
    }
  },
  computed: {
    galleryType() {
      if (!this.images) return; 
      if (this.images.length === 1) {
        return "gallery--one";
      } else if (this.images.length === 2) {
        return "gallery--two";
      } else {
        return "gallery--three";
      }
    }
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.gallery
  min-height $product-gallery-height
  position relative
  &--one 
    display flex
    align-items flex-start
    justify-content center
    & > img 
      display block
      width 90%
      @media only screen and (max-width: 700px)
        width 100%
  &--two
    & > .img-1
      display block
      position absolute
      left 0
      top 50%
      transform translateY(-50%)
      width 65%
      border-radius $product-gallery-border-radius
      z-index 2
      box-shadow $product-gallery-shadow-1
      transition all .2s
      &:hover
        z-index 4
        transform translateY(-50%) scale(1.1)
        box-shadow $product-gallery-shadow-1-raised 
      @media only screen and (max-width: 900px)
        width 75%
        left 50%
        transform translate(-50%, -50%)
        &:hover
          transform translate(-50%, -50%) scale(1.1)
      @media only screen and (max-width: 720px)
        top 40%
      @media only screen and (max-width: 600px)
        width 95%
    & > .img-2
      display block
      width 40%
      border-radius $product-gallery-border-radius
      position absolute
      left 70%
      bottom -3rem
      transform translateX(-50%)
      z-index 3
      box-shadow $product-gallery-shadow-1
      transition all .2s
      &:hover
        z-index 4
        transform translateX(-50%) scale(1.1)
        box-shadow $product-gallery-shadow-1-raised 
      @media only screen and (max-width: 900px)
        width 60%
        left 50%
        bottom -35%
        transform translate(-50%, -50%)
        &:hover
          transform translate(-50%, -50%) scale(1.1)
      @media only screen and (max-width: 720px)
        bottom -10%
      @media only screen and (max-width: 600px)
        width 80%
        bottom -35%
      @media only screen and (max-width: 500px)
        width 80%
        bottom -10%
  &--three
    & > .img-1
      display block
      position absolute
      left 50%
      top 50%
      transform translate(-50%, -50%)
      width 55%
      border-radius $product-gallery-border-radius
      z-index 2
      box-shadow $product-gallery-shadow-1
      transition all .2s
      &:hover
        z-index 4
        transform translate(-50%, -50%) scale(1.1)
        box-shadow $product-gallery-shadow-1-raised 
      @media only screen and (max-width: 700px)
        width 80%
      @media only screen and (max-width: 500px)
        width 95%
    & > .img-2
      display block
      width 35%
      border-radius $product-gallery-border-radius
      position absolute
      right 0
      bottom -.5rem
      z-index 3
      box-shadow $product-gallery-shadow-2
      transition all .2s
      &:hover
        z-index 4
        transform scale(1.1)
        box-shadow $product-gallery-shadow-2-raised
      @media only screen and (max-width: 800px)
        bottom 5rem
      @media only screen and (max-width: 700px)
        bottom 0
        right 50%
        z-index 1
        transform translateX(50%)
        width 70%
        &:hover
          transform translateX(50%) scale(1.1)
      @media only screen and (max-width: 500px)
        width 85%
    & > .img-3
      display block
      width 35%
      border-radius $product-gallery-border-radius
      position absolute
      left 0
      bottom -.5rem
      z-index 3
      box-shadow $product-gallery-shadow-2
      transition all .2s
      &:hover
        z-index 4
        transform scale(1.1)
        box-shadow $product-gallery-shadow-2-raised
      @media only screen and (max-width: 800px)
        bottom 5rem
      @media only screen and (max-width: 700px)
        top 0
        right 50%
        z-index 1
        transform translateX(50%)
        width 70%
        &:hover
          transform translateX(50%) scale(1.1)
      @media only screen and (max-width: 500px)
        width 85%
.img
  display none
</style>